#ifndef LIBRARIES_EXPNAME_H
#define LIBRARIES_EXPNAME_H     (1)
/*
**      $VER: expname.i 2.0 (8.4.96)
**
**      expname.library definitions
**
**      (C) Copyright 1995-96 Richard Koerber
**      All Rights Reserved.
*/

#ifndef EXEC_TYPES_H
#include 'exec/types.h'
#endif

#ifndef EXEC_LIBRARIES_H
#include 'exec/libraries.h'
#endif

/* ------------------------------------------------------------------------
**  Generic library informations
*/
#define EXPNAMEVERSION  (2)
struct ExpnameBase {
        struct  Library enb_LibNode;
};

#define EXPNAMEBUFLEN   (50)

/* ------------------------------------------------------------------------
**  String Types
*/
#define EXPTYPE_SYSTEM  (0)     /*  System (Amiga,DraCo,...) */
#define EXPTYPE_CPU     (1)     /*  CPU (68000,68010,...,68060) */
#define EXPTYPE_FPU     (2)     /*  FPU (---,68881,68882,68040,68060) */
#define EXPTYPE_MMU     (3)     /*  MMU (---,68852,68030,68040,68060) */
#define EXPTYPE_OSVER   (4)     /*  OS Version (V*.*) */
#define EXPTYPE_EXECVER (5)     /*  Exec Version (V*.*) */
#define EXPTYPE_WBVER   (6)     /*  Workbench Version (---,V*.*) */
#define EXPTYPE_ROMSIZE (7)     /*  OS ROM Size (*KB, *MB) */
#define EXPTYPE_CHIPSET (8)     /*  Chipset (OCS,ECS,AGA,DraCo) */
#define EXPTYPE_GFXSYS  (9)     /*  Graphics system (AmigaOS, CyberGraphX, ...) */
#define EXPTYPE_CHIPRAM (10)    /*  Chip RAM (*KB, *MB, *GB) */
#define EXPTYPE_FASTRAM (11)    /*  Fast RAM (*KB, *MB, *GB) */
#define EXPTYPE_RAM     (12)    /*  Total RAM (*KB, *MB, *GB) */

/* ------------------------------------------------------------------------
**  That's all...
*/
#endif


