        IFND    LIBRARIES_EXPNAME_I
LIBRARIES_EXPNAME_I    SET     1
**
**      $VER: expname.i 2.0 (8.4.96)
**
**      expname.library definitions
**
**      (C) Copyright 1995-96 Richard Koerber
**      All Rights Reserved.
**

                IFND    EXEC_TYPES_I
                INCLUDE 'exec/types.i'
                ENDC

                IFND EXEC_LIBRARIES_I
                INCLUDE 'exec/libraries.i'
                ENDC

*------------------------------------------------------------------------*
* Generic library informations
*
EXPNAMENAME     MACRO
                dc.b    "expname.library",0
                ENDM

EXPNAMEVERSION  EQU     2

    STRUCTURE ExpnameBase,0
        STRUCT  enb_LibNode,LIB_SIZE
        LABEL   enb_SIZEOF

EXPNAMEBUFLEN   EQU     50

*------------------------------------------------------------------------*
* String Types
*
EXPTYPE_SYSTEM  EQU     0       ; System (Amiga,DraCo,...)
EXPTYPE_CPU     EQU     1       ; CPU (68000,68010,...,68060)
EXPTYPE_FPU     EQU     2       ; FPU (---,68881,68882,68040,68060)
EXPTYPE_MMU     EQU     3       ; MMU (---,68852,68030,68040,68060)
EXPTYPE_OSVER   EQU     4       ; OS Version (V*.*)
EXPTYPE_EXECVER EQU     5       ; Exec Version (V*.*)
EXPTYPE_WBVER   EQU     6       ; Workbench Version (---,V*.*)
EXPTYPE_ROMSIZE EQU     7       ; OS ROM Size (*KB, *MB)
EXPTYPE_CHIPSET EQU     8       ; Chipset (OCS,ECS,AGA,DraCo)
EXPTYPE_GFXSYS  EQU     9       ; Graphics system (AmigaOS, CyberGraphX, ...)
EXPTYPE_CHIPRAM EQU     10      ; Chip RAM (*KB, *MB, *GB)
EXPTYPE_FASTRAM EQU     11      ; Fast RAM (*KB, *MB, *GB)
EXPTYPE_RAM     EQU     12      ; Total RAM (*KB, *MB, *GB)

*------------------------------------------------------------------------*
* That's all...
*
        ENDC

